//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "MainU.h"
#include "ContactDlgU.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMainForm *MainForm;

const int cnGroup  = 0;
const int cnPerson = 4;
const int cnContact = 8;

const char * cssContactType[] = {
	"绰",
	"Email",
	"վ",
	"ַ"
};
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
	: TForm(Owner),
    FCtrl( new TMainController( ) ),
    FAbout( new TAboutDialog( this ) ),
    FPoint( -1, -1 )
{
    FAbout->Freeware = true;
    FAbout->ReleaseDate = "2007";
    FAbout->Licence->Text = "License : See License.txt\r\n\
Credits :\r\n\
Zeos Development Group. - http://www.zeoslib.sourceforge.net\r\n\
Mark James. - http://www.famfamfam.com/lab/icons/silk/";
}
//---------------------------------------------------------------------------
//  controller
//---------------------------------------------------------------------------
void __fastcall TMainController::FilterTree( TDM::TFilterType aFilterType )
{
	TZQuery * pQuery = DM->GetTreeData( aFilterType, MainForm->editFilter->Text.Trim( ) );
	MainForm->tvPerson->Items->BeginUpdate( );
    try {
        MainForm->tvPerson->Items->Clear( );
        pQuery->First( );
        TTreeNode * pGroup = NULL;
        TTreeNode * pPerson = NULL;
        while ( !pQuery->Eof )
        {
            if ( ( !pGroup ) || ( reinterpret_cast<int>( pGroup->Data )
                != pQuery->FieldByName( "gid" )->AsInteger ) ) {
                pGroup = MainForm->tvPerson->Items->AddChild( NULL, pQuery->FieldByName( "title" )->AsString );
                pGroup->Data = reinterpret_cast<void *>( pQuery->FieldByName( "gid" )->AsInteger );
                pGroup->ImageIndex = cnGroup;
                pGroup->SelectedIndex = cnGroup;
            }
            if ( !pQuery->FieldByName( "pid" )->IsNull ) {
                pPerson = MainForm->tvPerson->Items->AddChild( pGroup, pQuery->FieldByName( "name" )->AsString );
                pPerson->Data = reinterpret_cast<void *>( pQuery->FieldByName( "pid" )->AsInteger );
                pPerson->ImageIndex = cnPerson;
                pPerson->SelectedIndex = cnPerson;
            }
            pQuery->Next();
        }
        pQuery->Close( );
    } catch (...) {
    }
	MainForm->tvPerson->Items->EndUpdate( );
	if ( MainForm->tvPerson->Items->Count > 0 ) {
		TTreeNode * pNode = MainForm->tvPerson->Items->Item[0];
		while ( pNode ) {
			pNode->Expand( true );
			pNode = pNode->getNextSibling( );
		}
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainController::AddGroup( TTreeNode * aNode, AnsiString S )
{
    int n = -1;
    AnsiString sName;
    for ( int i = 0 ; n == -1 && i < 100; i++ ) {
        try {
            sName = ( i > 0 ) ? S + "(" + IntToStr( i ) + ")" : S;
            n = DM->AddGroup( sName );
        } catch (...) {
        }
    }
    if ( n == -1 ) {
		MessageBox( MainForm->Handle, "ϵʧܣı", "",
            MB_ICONWARNING | MB_OK );
    }
    aNode->Text = sName;
	aNode->Data = reinterpret_cast<void *>( n );
}
//---------------------------------------------------------------------------
void __fastcall TMainController::AddPerson( TTreeNode * aNode, AnsiString S )
{
    if ( S.Trim( ) == "" ) {
        MessageBox( MainForm->Handle, "ϵΪգ", "", MB_ICONWARNING | MB_OK );
        return;
    }
    if ( aNode->Level != 1 ) {
        MessageBox( MainForm->Handle, "ڲ󣺴˽ڵ㲻ϵˣ", "", MB_ICONWARNING | MB_OK );
        return;
    }
    int nGID = reinterpret_cast<int>( aNode->Parent->Data );
    int n = -1;
    AnsiString sName;
    for ( int i = 0 ; n == -1 && i < 100; i++ ) {
        try {
            sName = ( i > 0 ) ? S.Trim( ) + IntToStr( i ) : S.Trim( );
            n = DM->AddPerson( nGID, sName, "" );
        } catch (...) {
        }
    }
    if ( n == -1 ) {
		MessageBox( MainForm->Handle, "ϵʧܣı", "",
            MB_ICONWARNING | MB_OK );
    }
    aNode->Text = sName;
	aNode->Data = reinterpret_cast<void *>( n );
}
//---------------------------------------------------------------------------
//  public
void __fastcall TMainController::CmdRefreshTree( )
{
	TDM::TFilterType ft = TDM::ftAll;
	if ( MainForm->editFilter->Text.Trim() != "" ) {
		ft = TDM::TFilterType( MainForm->cbFilterType->ItemIndex + 1 );
	}
	FilterTree( ft );
}
//---------------------------------------------------------------------------
void __fastcall TMainController::CmdRefreshPerson( )
{
    if ( !MainForm->tvPerson->Selected ) {
        CmdClearPerson( );
        return;
    }
    AnsiString s;
	TZQuery * pQuery = DM->GetPersonData( reinterpret_cast<int>( MainForm->tvPerson->Selected->Data ), s );
    MainForm->memoPersonDesc->Lines->Text = s;
	MainForm->lvContact->Items->BeginUpdate( );
    int n;
    TDateTime dt;
    try {
        MainForm->lvContact->Items->Clear( );
        pQuery->First( );
        TListItem * pItem;
        while ( !pQuery->Eof )
        {
            pItem = MainForm->lvContact->Items->Add( );
            dt = pQuery->FieldByName( "validate" )->AsDateTime;
            pItem->Data = reinterpret_cast<void *>( pQuery->FieldByName( "cid" )->AsInteger );
            pItem->Caption = FormatDateTime( "yyyy-mm-dd", dt );
            pItem->SubItems->Add( pQuery->FieldByName( "typename" )->AsString );
            pItem->SubItems->Add( cssContactType[pQuery->FieldByName( "ctid" )->AsInteger] );
            pItem->SubItems->Add( pQuery->FieldByName( "contact" )->AsString );
            pItem->ImageIndex = cnContact;
            pQuery->Next( );
        }
        pQuery->Close( );
    } catch (...) {
    }
	MainForm->lvContact->Items->EndUpdate( );
}
//---------------------------------------------------------------------------

void __fastcall TMainController::CmdClearPerson( )
{
	MainForm->memoPersonDesc->Lines->Text = "";
	MainForm->lvContact->Items->BeginUpdate( );
	MainForm->lvContact->Items->Clear( );
    MainForm->lvContact->Items->EndUpdate( );
}
//---------------------------------------------------------------------------
void __fastcall TMainController::CmdAddGroup( )
{
	TTreeNode * pNode = MainForm->tvPerson->Items->AddChild( NULL, "ϵ" );
    pNode->ImageIndex = cnGroup;
    pNode->SelectedIndex = cnGroup;
    AddGroup( pNode, pNode->Text );
	MainForm->tvPerson->Selected = pNode;
	pNode->EditText( );
}
//---------------------------------------------------------------------------
void __fastcall TMainController::CmdEditGroup( )
{
	if ( MainForm->tvPerson->Selected && MainForm->tvPerson->Selected->Level == 0 ) {
		MainForm->tvPerson->Selected->EditText();
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainController::CmdEditedGroup( TTreeNode * aNode, AnsiString S )
{
	try {
		if ( S.Trim() == "" ) {
			throw Exception( "ıΪգ" );
		}
		int n = reinterpret_cast<int>( aNode->Data );
		DM->EditGroup( n, S );
	} catch (...) {
		MessageBox( MainForm->Handle, "޸ϵʧܣı", "", MB_ICONWARNING | MB_OK );
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainController::CmdDelGroup( )
{
	if ( MainForm->tvPerson->Selected && MainForm->tvPerson->Selected->Level == 0 ) {
		if ( MainForm->tvPerson->Selected->Count == 0 ) {
            if ( MessageBox( MainForm->Handle, "ȷҪɾϵ", "",
                MB_ICONWARNING | MB_YESNO ) == IDYES ) {
                DM->DelGroup( reinterpret_cast<int>( MainForm->tvPerson->Selected->Data ) );
                MainForm->tvPerson->Items->Delete( MainForm->tvPerson->Selected );
            }
		}
		else
		    MessageBox( MainForm->Handle, "ϵ»ϵˣɾ", "", MB_ICONWARNING | MB_OK );
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainController::CmdAddPerson( )
{
    if ( MainForm->tvPerson->Selected && MainForm->tvPerson->Selected->Level == 0 ) {
        TTreeNode * pNode = MainForm->tvPerson->Items->AddChild( MainForm->tvPerson->Selected, "ϵ" );
        pNode->ImageIndex = cnPerson;
        pNode->SelectedIndex = cnPerson;
        AddPerson( pNode, pNode->Text );
        MainForm->tvPerson->Selected->Expand( false );
        MainForm->tvPerson->Selected = pNode;
        pNode->EditText( );
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainController::CmdEditPerson( )
{
	if ( MainForm->tvPerson->Selected && MainForm->tvPerson->Selected->Level == 1 )
        MainForm->tvPerson->Selected->EditText( );
}
//---------------------------------------------------------------------------
void __fastcall TMainController::CmdEditedPerson( TTreeNode * aNode, AnsiString S,
    AnsiString aDesc )
{
	try {
		if ( S.Trim() == "" ) {
			throw Exception( "ϵΪգ" );
		}
        if ( aNode->Level != 1 ) {
            throw Exception( "ڲ󣺴˽ڵ㲻ϵˣ" );
        }
		int n = reinterpret_cast<int>( aNode->Data );
        DM->EditPerson( n, S, aDesc );
	} catch (...) {
		MessageBox( MainForm->Handle, "޸ϵʧܣı", "", MB_ICONWARNING | MB_OK );
	}
}
//---------------------------------------------------------------------------

void __fastcall TMainController::CmdEditPersonDesc( )
{
    if ( MainForm->tvPerson->Selected->Level == 1 ) {
        DM->EditPerson( reinterpret_cast<int>( MainForm->tvPerson->Selected->Data ),
            MainForm->tvPerson->Selected->Text,
            MainForm->memoPersonDesc->Lines->Text.Trim( ) );
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainController::CmdEditPersonGrp( TTreeNode * aNewGroup )
{
    DM->EditPerson( reinterpret_cast<int>( MainForm->tvPerson->Selected->Data ),
        MainForm->tvPerson->Selected->Text,
        MainForm->memoPersonDesc->Lines->Text.Trim( ),
        reinterpret_cast<int>( aNewGroup->Data ) );
    MainForm->tvPerson->Selected->MoveTo( aNewGroup, naAddChild );
}
//---------------------------------------------------------------------------
void __fastcall TMainController::CmdDelPerson( )
{
	if ( MainForm->tvPerson->Selected && MainForm->tvPerson->Selected->Level == 1 ) {
        if ( MainForm->lvContact->Items->Count == 0 ) {
            if ( MessageBox( MainForm->Handle, "ȷҪɾϵ", "",
                MB_ICONWARNING | MB_YESNO ) == IDYES ) {
                DM->DelPerson( reinterpret_cast<int>( MainForm->tvPerson->Selected->Data ) );
                MainForm->tvPerson->Items->Delete( MainForm->tvPerson->Selected );
                CmdRefreshPerson( );
            }
        }
        else {
            MessageBox( MainForm->Handle, "ϵ»ϵʽɾ", "", MB_ICONWARNING | MB_OK );
        }
	}
}
//---------------------------------------------------------------------------
void __fastcall TMainController::CmdAddContact( )
{
    if ( MainForm->tvPerson->Selected ) {
        TListItem * pItem = ( MainForm->lvContact->Items->Count > 0 ) ?
            MainForm->lvContact->Items->Item[MainForm->lvContact->Items->Count - 1] : NULL;
        TPoint pt( MainForm->lvContact->Columns->Items[0]->Width,
            ( pItem ) ? pItem->Top : 0 );
        pt = MainForm->lvContact->ClientToScreen( pt );
        ContactDlg->Left = pt.x - ContactDlg->btnOk->Width * 2;
        ContactDlg->Top  = pt.y + ContactDlg->Height - 3;
        ContactDlg->cbCategory->Width = MainForm->lvContact->Columns->Items[1]->Width;
        ContactDlg->cbCType->Width = MainForm->lvContact->Columns->Items[2]->Width;
//        ContactDlg->editContact->Width = lvContact->Columns->Items[3]->Width;
        ContactDlg->Width = MainForm->lvContact->Width - MainForm->lvContact->Columns->Items[0]->Width
            + ContactDlg->btnOk->Width;
        if ( ContactDlg->cbCategory->Items->Count == 0 ) {
            TZQuery * pQuery = DM->GetCategories( );
            pQuery->First( );
            while ( !pQuery->Eof ) {
                ContactDlg->cbCategory->Items->AddObject(
                    pQuery->FieldByName( "typename" )->AsString,
                    reinterpret_cast<TObject *>( pQuery->FieldByName( "ccid" )->AsInteger ) );
                pQuery->Next( );
            }
            pQuery->Close( );
        }
        ContactDlg->cbCategory->ItemIndex = 0;
        ContactDlg->editContact->Text = "";
        int nPID = reinterpret_cast<int>( MainForm->tvPerson->Selected->Data);
        if ( ContactDlg->ShowModal( ) == mrOk ) {
            DM->AddContact( nPID,
                reinterpret_cast<int>( ContactDlg->cbCategory->Items->Objects[ContactDlg->cbCategory->ItemIndex] ),
                ContactDlg->cbCType->ItemIndex, ContactDlg->editContact->Text.Trim( ) );
            CmdRefreshPerson( );
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainController::CmdDelContact( )
{
	if ( MainForm->lvContact->Selected ) {
        if ( MessageBox( MainForm->Handle, "ȷҪɾϵʽ", "",
            MB_ICONWARNING | MB_YESNO ) == IDYES ) {
            DM->DelContact( reinterpret_cast<int>( MainForm->lvContact->Selected->Data ) );
            MainForm->lvContact->Items->Delete( MainForm->lvContact->Selected->Index );
        }
	}
}
//---------------------------------------------------------------------------
//  view
//---------------------------------------------------------------------------

void __fastcall TMainForm::pmTreePopup(TObject *Sender)
{
    if ( pmTree->PopupComponent == tvPerson ) {
        TPoint pt;
        TTreeNode * pNode;

        GetCursorPos( &pt );
        pt = tvPerson->ScreenToClient( pt );
        pNode = tvPerson->GetNodeAt( pt.x, pt.y );
        if ( pNode ) {
            tvPerson->Selected = pNode;
        }
        if ( !tvPerson->Selected ) {
            pmiAdd->Action   = this->actAddGroup;
            pmiEdit->Enabled = false;
            pmiDel->Enabled  = false;
        }
        else if ( tvPerson->Selected->Level == 0 ) {
            pmiAdd->Action  = this->actAddPerson;
            pmiEdit->Action = this->actEditGroup;
            pmiDel->Action  = this->actDelGroup;
        }
        else {
            pmiAdd->Action  = this->actAddContact;
            pmiEdit->Action = this->actEditPerson;
            pmiDel->Action  = this->actDelPerson;
        }
    }
    else {
        pmiAdd->Action   = this->actAddContact;
        pmiDel->Action   = this->actDelContact;
        pmiEdit->Enabled = false;
        pmiEdit->Visible = false;
        if ( !tvPerson->Selected || tvPerson->Selected->Level != 1 )
        {
            pmiAdd->Enabled = false;
            pmiDel->Enabled = false;
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::actRefreshExecute(TObject *Sender)
{
	FCtrl->CmdRefreshTree( );
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::actAddGroupExecute(TObject *Sender)
{
	FCtrl->CmdAddGroup( );
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::actEditGroupExecute(TObject *Sender)
{
	FCtrl->CmdEditGroup( );
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::actDelGroupExecute(TObject *Sender)
{
	FCtrl->CmdDelGroup( );
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::actAddPersonExecute(TObject *Sender)
{
	FCtrl->CmdAddPerson( );
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::actEditPersonExecute(TObject *Sender)
{
	FCtrl->CmdEditPerson( );
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::actDelPersonExecute(TObject *Sender)
{
	FCtrl->CmdDelPerson( );
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::actAddContactExecute(TObject *Sender)
{
	FCtrl->CmdAddContact( );
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::actDelContactExecute(TObject *Sender)
{
	FCtrl->CmdDelContact( );
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::miExitClick(TObject *Sender)
{
	Close( );
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::miHelpAboutClick(TObject *Sender)
{
    FAbout->Execute( );
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::FormShow(TObject *Sender)
{
	FCtrl->CmdRefreshTree( );
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::tvPersonEdited(TObject *Sender, TTreeNode *Node,
	  AnsiString &S)
{
    if ( Node ) {
        if ( Node->Level == 0 )
            FCtrl->CmdEditedGroup( Node, S );
        else
            FCtrl->CmdEditedPerson( Node, S, memoPersonDesc->Lines->Text );
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::tvPersonChange(TObject *Sender, TTreeNode *Node)
{
    if ( Node ) {
        if ( Node->Level == 1 )
            FCtrl->CmdRefreshPerson();
        else
            FCtrl->CmdClearPerson();
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::memoPersonDescExit(TObject *Sender)
{
    FCtrl->CmdEditPersonDesc( );
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::lvContactDblClick(TObject *Sender)
{
    FCtrl->CmdAddPerson( );
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::tvPersonChanging(TObject *Sender, TTreeNode *Node,
      bool &AllowChange)
{
    if ( this->ActiveControl == this->memoPersonDesc ) {
        FCtrl->CmdEditPersonDesc( );
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::tvPersonMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if ( Button == mbLeft && tvPerson->Selected && tvPerson->Selected->Level == 1 ) {
        FPoint.x = X;
        FPoint.y = Y;
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::tvPersonMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
    if ( FPoint.x >= 0 && FPoint.y >= 0 ) {
        double dx = abs( ( double )X - FPoint.x );
        double dy = abs( ( double )Y - FPoint.y );
        if ( dx * dx + dy * dy > 5 ) {
            tvPerson->BeginDrag( true, 0 );
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::tvPersonMouseUp(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
{
    FPoint.x = -1;
    FPoint.y = -1;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::tvPersonDragOver(TObject *Sender, TObject *Source,
      int X, int Y, TDragState State, bool &Accept)
{
    Accept = false;
    TTreeNode * p = tvPerson->GetNodeAt( X, Y );
    if ( !p ) {
        return;
    }
    if ( !p->Expanded && tvPerson->GetHitTestInfoAt( X, Y ).Contains( htOnButton ) ) {
        p->Expand( false );  //  +ʱչ
    }
    if ( Y < 8 && tvPerson->TopItem->GetPrevVisible( ) ) {
        tvPerson->TopItem = tvPerson->TopItem->GetPrevVisible( );
    }
    if ( ( Y > tvPerson->Height - 32 ) && tvPerson->TopItem->GetNextVisible( ) ) {
        tvPerson->TopItem = tvPerson->TopItem->GetNextVisible( );
    }
    if ( Source == tvPerson && p->Level == 0 && p != tvPerson->Selected
        && p != tvPerson->Selected->Parent ) {
        Accept = true;
    }
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::tvPersonDragDrop(TObject *Sender, TObject *Source,
      int X, int Y)
{
    FPoint.x = -1;
    FPoint.y = -1;
    TTreeNode * p = tvPerson->GetNodeAt( X, Y );
    if ( p ) {
        FCtrl->CmdEditPersonGrp( p );
    }
}
//---------------------------------------------------------------------------

