//---------------------------------------------------------------------------

#include "DUnitBCB.h"
#pragma hdrstop

#include "ModuleTestCase.h"

//---------------------------------------------------------------------------

#pragma package(smart_init)

static int dummy = TestInitialization( __classid( TModuleTestCase ) );
//---------------------------------------------------------------------------

void __fastcall TModuleTestCase::SetUp( void )
{
    DM = new TDM( NULL );
}
//---------------------------------------------------------------------------

void __fastcall TModuleTestCase::TearDown( void )
{
    delete DM;
    DM = NULL;
}
//---------------------------------------------------------------------------

TZQuery * __fastcall TModuleTestCase::FindGroup( int aGID )
{
    TZQuery * qry = DM->GetTreeData( TDM::ftAll, "" );
    Variant vGID[1];
    vGID[0] = aGID;
    if ( !qry->Locate( "gid", VarArrayOf( vGID, 0 ), TLocateOptions() ) ) {
        qry->Close( );
    }
    return qry;
}
//---------------------------------------------------------------------------

TZQuery * __fastcall TModuleTestCase::FindPerson( int aPID )
{
    TZQuery * qry = DM->GetTreeData( TDM::ftAll, "" );
    Variant vGID[1];
    vGID[0] = aPID;
    if ( !qry->Locate( "pid", VarArrayOf( vGID, 0 ), TLocateOptions() ) ) {
        qry->Close( );
    }
    return qry;
}
//---------------------------------------------------------------------------

TZQuery * __fastcall TModuleTestCase::FindContact( int aPID, int aCID )
{
    AnsiString sDesc;
    TZQuery * qry = DM->GetPersonData( aPID, sDesc );
    Variant vGID[1];
    vGID[0] = aCID;
    if ( !qry->Locate( "cid", VarArrayOf( vGID, 0 ), TLocateOptions() ) ) {
        qry->Close( );
    }
    return qry;
}
//---------------------------------------------------------------------------

void __fastcall TModuleTestCase::TestGroup( void )
{
    int g = DM->AddGroup( "Test" );
    Check( g > 0, "ϵʧ" );

    DM->EditGroup( g, "޸Test" );
    TZQuery * qry = FindGroup( g );
    Check( qry->Active, "ϵδҵ" );
    Check( qry->FieldByName( "title" )->AsString == "޸Test", "޸ϵʧ" );
    qry->Close( );

    DM->DelGroup( g );
    qry = FindGroup( g );
    Check( !qry->Active, "ϵδɾ" );
    qry->Close( );
}
//---------------------------------------------------------------------------

void __fastcall TModuleTestCase::TestPerson( void )
{
    int g1 = DM->AddGroup( "Test1" );
    int g2 = DM->AddGroup( "Test2" );

    int p1 = DM->AddPerson( g1, "Test1", "" );
    Check( p1 > 0, "ϵʧ" );
    int p2 = DM->AddPerson( g2, "Test2", "" );

    DM->EditPerson( p1, "޸", "" );
    TZQuery * qry = FindPerson( p1 );
    Check( qry->Active, "ϵδҵ" );
    Check( qry->FieldByName( "name" )->AsString == "޸", "޸ϵʧ" );
    qry->Close( );

    DM->EditPerson( p2, "޸2", "2", g1 );
    qry = FindPerson( p1 );
    Check( qry->Active, "ϵδҵ" );
    Check( qry->FieldByName( "gid" )->AsString == g1, "ƶϵʧ" );
    qry->Close( );

    DM->DelPerson( p2 );
    qry = FindPerson( p2 );
    Check( !qry->Active, "ϵδɾ" );
    qry->Close( );
    DM->DelPerson( p1 );

    DM->DelGroup( g2 );
    DM->DelGroup( g1 );  
}
//---------------------------------------------------------------------------

void __fastcall TModuleTestCase::TestContact( void )
{
    int g = DM->AddGroup( "Test" );
    int p = DM->AddPerson( g, "Test", "" );

    int c1 = DM->AddContact( p, 1, //  CCID : ͥ칫ˣ
    0, //  CTID : 绰EMAILַվ
    "1234567" );
    Check( c1 > 0, "ϵʽʧ" );
    int c2 = DM->AddContact( p, 2, 2, "XXʡXXXX·XXŪXX¥XXXX" );
    Check( c2 > 0, "ϵʽʧ" );

    DM->DelContact( c1 );
    TZQuery * qry = FindContact( p, c1 );
    Check( !qry->Active, "ϵʽδɾ" );
    qry->Close( );
    DM->DelContact( c2 );

    DM->DelPerson( p );
    DM->DelGroup( g );  
}
//---------------------------------------------------------------------------

